/* eslint-env browser */

import * as Y from 'yjs';
import { WebrtcProvider } from '../client/y-webrtc';

const ydoc = new Y.Doc();
const provider = new WebrtcProvider('prosemirror', ydoc);
const yarray = ydoc.get('prosemirror', Y.XmlFragment);

provider.on('synced', synced => {
  // NOTE: This is only called when a different browser connects to this client
  // Windows of the same browser communicate directly with each other
  // Although this behavior might be subject to change.
  // It is better not to expect a synced event when using y-webrtc
  console.log('synced!', synced);
});

yarray.observeDeep(() => {
  console.log('yarray updated: ', yarray.toJSON());
});

// @ts-ignore
window.example = { provider, ydoc, yarray };
